"""
A module with functions on dictionaries.

This module is a mix of functions using loops and functions
using recursion.

Author: Walker M. White (wmw2)
Date: October 24, 2020
"""


def merge(dict1,dict2):
    """
    Returns a new dictionary merging (joining keys) dict1
    and dict2.

    If a key appears in only one of dict1 or dict2, the value
    is the value from that dictionary. If it is in both, the
    value is the sum of values.

    Example: merge({'a':1,'b':2},{'b':3,'c':4}) returns
    {'a':1,'b':5,'c':4}

    Parameter dict1: The first dictionary to merge
    Precondition: dict1 a dictionary with int or float values

    Parameter dict2: The second dictionary to merge
    Precondition: dict2 a dictionary with int or float values
    """
    # Implement this
    pass


def histogram1(grades,acutoff,bcutoff):
    """
    Returns a histogram (dictionary) with the number of
    As, Bs, and Cs.

    The letter grades are the dictionary keys, and the
    values are the number of each grade. Any grade >= acutoff
    is an A.  Any other grade >= bcutoff is a B. All other
    grades are Cs.

    Example: Assume that
        example = { 'qsq4':80, 'dju6':90, 'wgo5':75, 'zkw9':60, 'wj8':74}
        histogram(example,90,75) returns {'A':1, 'B':2, 'C':2}
        histogram(example,80,60) returns {'A':2, 'B':3, 'C':0}
        histogram({},80,60) returns {'A':0, 'B':0, 'C':0}

    Parameter grade: The student grades
    Precondition: grades is a grade dictionary (may be empty).

    Parameter acutoff: The A cut off
    Precondition: acutoff a number with 0 < bcutoff < acutoff

    Parameter acutoff: The A cut off
    Precondition: acutoff a number with 0 < bcutoff < acutoff
    """
    # Do this with a for-loop
    pass


def histogram2(s):
    """
    Returns a histogram (dictionary) of the # of letters
    in string s.

    The letters in s are keys, and the count of each letter
    is the value. If the letter is not in s, then there is
    NO KEY for it in the histogram.

    Example: histogram('') returns {},
             histogram('all') returns {'a':1,'l':2}
             histogram('abracadabra') returns
                {'a':5,'b':2,'c':1,'d':1,'r':2}

    Parameter s: The string to analyze
    Precondition: s is a string (possibly empty).
    """
    # Do this one with divide-and-conquer
    pass
